*-- Class:		DataLinkedObjectManager
*-- ParentClass:	Custom
*-- BaseClass:		Custom

DEFINE CLASS DataLinkedObjectManager AS custom

	Name='DataLinkedObjectManager'
	
	** The list of clients to be driven by this manager
	DECLARE CLIENTS(1)
	
	** Number of registered clients
	NumberOfClients=0
	
	PROCEDURE NumberOfClients_access
		LOCAL lnNumberOfClients
		IF ALEN(THIS.Clients)=1 AND ISNULL(THIS.Clients(1))
			lnNumberOfClients=0
		ELSE
			lnNumberOfClients=ALEN(THIS.Clients)
		ENDIF
		RETURN lnNumberOfClients
	ENDPROC

	PROCEDURE NumberOfClients_assign
		LPARAMETERS vNewVal
		RETURN
	ENDPROC
	
	PROCEDURE Init
		THIS.Clients(1)=NULL
	ENDPROC
	
	PROCEDURE Release
		RELEASE THIS
	ENDPROC
	
	** Adds a new client into client list
	PROCEDURE AddClient
		LPARAMETERS loReference
		IF THIS.NumberOfClients=0
			THIS.Clients(1)=loReference
		ELSE
			DIMENSION THIS.Clients(THIS.NumberOfClients+1)
			THIS.Clients(THIS.NumberOfClients)=loReference
		ENDIF
	ENDPROC
	
	** Removes a specified client from client list
	PROCEDURE RemoveClient
		LPARAMETERS loReference
		LOCAL lnElement, llSuccess, lnIndex
		lnElement=0
		FOR lnIndex=1 to THIS.NumberOfClients
			IF THIS.Clients(lnIndex)=loReference
				lnElement=lnIndex
				EXIT
			ENDIF
		ENDFOR
		IF lnElement!=0
			IF THIS.NumberOfClients=1
				THIS.Clients(1)=NULL
			ELSE
				ADEL(THIS.Clients,lnElement)
				DIMENSION THIS.Clients(THIS.NumberOfClients-1)
			ENDIF
			llSuccess=.T.
		ELSE
			llSuccess=.F.
		ENDIF
		RETURN llSuccess
	ENDPROC	
	
	** Updates data sets of all registered clients	
	PROCEDURE UpdateAllClients
		LPARAMETERS loPushingObject
		LOCAL loCurrentObject
		IF THIS.NumberOfClients > 0
			FOR EACH loCurrentObject IN THIS.Clients
				IF loCurrentObject != loPushingObject
					loCurrentObject.RefreshData()
				ENDIF
			ENDFOR
		ENDIF
	ENDPROC
	
ENDDEFINE