DO FORM IPAddress
READ EVENTS

*!*	oIP = CreateObject("IPAddress")

*!*	lnEntries = oIP.nEntries - 1

*!*	FOR lnIndex = 0 TO lnEntries
*!*		? oIP.GetIPAddress(lnIndex)
*!*		? oIP.SubnetMask		
*!*	ENDFOR


*-- IPAddress : Allows developer to retrieve the 
*--             IP Addresses and subnet masks on 
*--             a system.
*-
*-- Copyright  2001 - RCS Solutions, Inc.
*-- Written by: Paul Mrozowski
*-- 11/4/2000

DEFINE CLASS IPAddress AS CUSTOM

*-- # of entries in the IP Address table
nEntries = 0
IPAddress = (SPACE(0))
SubnetMask = (SPACE(0))
    
Name = "IPAddress"

PROCEDURE Init()
    
* This is the "magic" declare

DECLARE INTEGER GetIpAddrTable IN Iphlpapi ;
        STRING @ pIpAddrTable, ;
        INTEGER @ pdwSize, ;
        INTEGER BORDER
           
ENDPROC

*-- Retrieve IP address.
PROCEDURE GetIPAddress
LPARAMETER tnEntry
LOCAL pdwSize, pIpAddrTable, lnStructSize, ;
      lnOffset, lnIPNum, lnSubNum, lnEntries, ;
      lcAddr

lnOffset = 5
lnStructSize = 24

pdwSize = 0
pIpAddrTable = " "

IF VARTYPE(tnEntry) = "N"

   * Call the Win function to get IP addresses
   * We pass it the pIPAddrTable variable by 
   * reference and it passes back the structure 
   * size back into pdwSize.

   GetIpAddrTable(@pIpAddrTable, @pdwSize, 1)

   * Make sure we set aside enough room for 
   * the info.
       
   pIpAddrTable = SPACE(pdwSize)

   * Call GetIPAddrTable again, this time we 
   * can get the information that we're 
   * really interested in.

   GetIpAddrTable(@pIpAddrTable, @pdwSize, 1)
   
   lcAddr = SUBSTR(pIpAddrTable, 1, 4)

   lnEntries = THIS.ConvertDWORDtoNum(lcAddr)
   THIS.nEntries = lnEntries

   * If they asked for a specific entry, get 
   * it as long as it exists

   IF tnEntry <= lnEntries - 1

      * We calculate the offset in the structure 
      * to get the IP Address, which is 4 bytes 
      * long (a DWORD). We also add in an offset 
      * from the entry value.

      lnIPNum = SUBSTR(pIpAddrTable, ;
                      (tnEntry * lnStructSize) ;
                      + lnOffset, 4)
                          
      THIS.IPAddress = THIS.ConvertToDot(lnIPNum)

      * Now get the subnet mask

      lnSubNum = SUBSTR(pIpAddrTable, ;
                       (tnEntry * lnStructSize) ;
                       + lnOffset + 8, 4)            
          
      THIS.SubnetMask = THIS.ConvertToDot(lnSubNum)
    ENDIF
ENDIF

RETURN THIS.IPAddress
ENDPROC

*-- Convert the passed in # to IP address "dot" format
PROCEDURE ConvertToDot
LPARAMETER tcDWORD
LOCAL lcByte0, lcByte1, lcByte2, lcByte3, lcIP

lcIP = ""

IF VARTYPE(tcDWORD) = "C"

* Same code as ConvertDWORDToNum, we just don't bother
* to convert it into a decimal since it's practically 
* in "dot" format already. Duplicated here for simplicity
* sake.

   lcByte0 = ASC(tcDWORD)
   lcByte1 = ASC(SUBSTR(tcDWORD, 2, 1))
   lcByte2 = ASC(SUBSTR(tcDWORD, 3, 1))
   lcByte3 = ASC(SUBSTR(tcDWORD, 4, 1))

   lcIP = ALLTRIM(STR(lcByte0)) + "." ;
        + ALLTRIM(STR(lcByte1)) + "." ;
        + ALLTRIM(STR(lcByte2)) + "." ;
        + ALLTRIM(STR(lcByte3))

ENDIF

RETURN lcIP
ENDPROC


PROCEDURE ConvertDWORDtoNum
LPARAMETER tcDWORD
LOCAL lcByte0, lcByte1, lcByte2, lcByte3, lnResult

IF VARTYPE(tcDWORD) = "C"
   lnResult = 0

   lcByte0 = ASC(tcDWORD)
   lcByte1 = ASC(SUBSTR(tcDWORD, 2, 1))
   lcByte2 = ASC(SUBSTR(tcDWORD, 3, 1))
   lcByte3 = ASC(SUBSTR(tcDWORD, 4, 1))

   lnResult = (((lcByte3 * 256 + lcByte2) * ;
              256 + lcByte1) * 256 + lcByte0)
ENDIF

RETURN lnResult
ENDPROC


PROCEDURE nEntries_access

THIS.GetIPAddress(0)
RETURN THIS.nEntries

ENDPROC


ENDDEFINE
